<?php
	
	list ($topic) = $irc_call_args;
	
	$topic = strtolower($topic);
	
	switch ($topic)
	{
	case 'mode':
	case 'modes':
	case 'start':
		notice($from, 'To start a game in special modes, type "!yandere join <modes>" where <modes> is one or more space-seperated modes:');
		notice($from, 'basic :Create a game containing only yanderes, spies, guardians, and civilians.');
		notice($from, 'invert :Game messages are displayed using inverted text.');
		notice($from, '+m :Restricted-voice mode. Only players can talk in the channel, and only at day.');
		notice($from, 'visible-roles :Roles are publicly announced at the beginning of the game and upon death.');
		notice($from, '<number> :The numbers of seconds allotted for joining the game. The default is 60.');
		return;
	
	case 'roles':
		notice($from, 'Type "!yandere help <role>" where <role> is one of: '.implode(', ', array_keys($this->custom_vars->yandere_role_descriptions)));
		return;
	
	default:
		if (false !== $key = array_search($topic, $this->custom_vars->yandere_role_plurals))
		{
			$topic = $key;
		}
		elseif (!isset ($this->custom_vars->yandere_role_plurals[$topic]))
		{
			notice($from, 'I don\'t know what that is.');
			return;
		}
		
		if (isset ($this->custom_vars->yandere_role_descriptions[$topic]))
		{
			notice($from, $this->custom_vars->yandere_role_descriptions[$topic]);
		}
		else
		{
			notice($from, 'I don\'t have a description for that yet.');
		}
		
		return;
	}
	
?>
