<?php
	
	list ($user_id, $params) = $irc_call_args;
	
	if ($from == $to)
	{
		output($from, 'Please type that in the channel, not in PM.');
		return;
	}
	
	foreach ($this->custom_vars->yandere_games as $channel => $game)
	{
		if (isset ($game->players[$user_id]))
		{
			// The user is already in a game.
			
			if ($channel == irc_lower($to))
			{
				notice($from, 'You\'re already in the ' . ($game->active ? '' : 'pending ') . 'game.');
			}
			else
			{
				output($to, $from.': You\'re already playing a yandere game on this network. You can only be in one at a time.');
			}
			
			return;
		}
	}
	
	$channel = irc_lower($to);
	
	if (!isset ($this->custom_vars->yandere_games[$channel]))
	{
		// Start a new game.
		
		$game = $this->custom_vars->yandere_games[$channel] = new Yandere_game($this, $channel);
		
		$game->starter = $user_id;
		$game->start_time = time();
		
		//$game->restrict_voice = $this->channel($to)->is_op($this->nick);
		$game->restrict_voice = false;
		$game->blind_roles = 1;
		$game->complexity = 'normal';
		$game->s = BOLD;
		$game->e = BOLD;
		$game->start_mode = null;
		$delay = 60;
		$game->max_extensions = 1;
		$game->forbid_early_kill = false;
		
		foreach ($params as $param)
		{
			$params = strtolower($param);
			
			switch ($param)
			{
			case 'allow-early-kill':
			case 'allow-early-kills':
				$game->forbid_early_kill = false;
				break;
			
			case 'basic':
			case 'simple':
				$game->complexity = 'basic';
				break;
			
			case 'blind':
			case 'blind-roles':
				$game->blind_roles = true;
				break;
			
			case 'blind-random':
			case 'blind-rand':
			case 'random-blind':
			case 'rand-blind':
				$game->blind_roles = mt_rand(0, 1) == 1;
				break;
			
			case 'bold':
			case 'bold-text':
				$game->s = BOLD;
				$game->e = BOLD;
				break;
			
			case 'day':
				$game->start_mode = 'day';
				break;
			
			case 'forbid-early-kill':
			case 'forbid-early-kills':
				$game->forbid_early_kill = true;
				break;
			
			case 'invert':
			case 'invert-text':
			case 'inverted':
			case 'inverted-text':
			case 'reverse':
			case 'reverse-text':
			case 'reversed':
			case 'reversed-text':
				$game->s = REVERSE;
				$game->e = REVERSE;
				break;
			
			case '+m':
			case 'm':
			case 'moderated':
			case 'no-voice':
			case 'restrict-voice':
			case 'restricted-voice':
				$game->restrict_voice = true;
				break;
			
			case '-m':
			case 'unmoderated':
			case 'unrestrict-voice':
			case 'unrestricted-voice':
				$game->restrict_voice = false;
				break;
			
			case 'night':
				$game->start_mode = 'night';
				break;
			
			case 'normal':
			case 'standard':
				$game->complexity = 'normal';
				break;
			
			case 'normal-text':
			case 'plain-text':
				$game->s = '';
				$game->e = '';
				break;
			
			case 'visible-roles':
				$game->blind_roles = false;
				break;
			
			default:
				if (ctype_digit($param))
				{
					$delay = $param;
				}
				else
				{
					unset ($this->custom_vars->yandere_games[$channel]);
					
					output($to, 'I don\'t recognize "'.$param.'" as a mode.');
					
					call('yandere/help', 'modes');
					
					return;
				}
			}
		}
		
		if ($game->restrict_voice && !$this->channel($to)->is_op($this->nick))
		{
			// The bot doesn't have ops.
			
			output($to, 'We can\'t play a restricted-voice yandere game in here unless someone gives me ops.');
			
			unset ($this->custom_vars->yandere_games[$channel]);
			return;
		}
		
		output($to, $game->s.'A yandere game is starting in '.$delay.' '.str_plural('second', $delay).'! Please type "!yandere" to join.'.$game->e);
		
		$this->schedule_event(time() + $delay, array ('yandere/start-game', $channel, $game->start_time, 0));
	}
	elseif ($this->custom_vars->yandere_games[$channel]->active)
	{
		notice($from, 'The game is already in progress.');
		return;
	}
	
	notice($from, 'You\'ve joined the pending game.');
	
	$game = $this->custom_vars->yandere_games[$channel];
	
	$user = $game->players[$user_id] = new Yandere_user($game, $user_id, $from);
	
?>
